#include <grass/config.h>
#include <sys/types.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <float.h>
#include <grass/gis.h>
#include <grass/raster.h>
#include "tinf.h"
#include "local.h"
#include <stdio.h>
#include <grass/config.h>
#include <grass/gis.h>
#include <grass/glocale.h>
#include <grass/la.h>


int matrix_read_elev(int infd, mat_struct *out, int rows, int cols, int type)
{
    CELL *cell;
    G_matrix_set(out, rows, cols, rows);
    int i,j;
    for (i = 0; i < rows; i ++) {
        cell = Rast_allocate_c_buf();
        Rast_get_c_row(infd, cell, i);
        for(j=0;j< cols;j++) {
            G_matrix_set_element(out,i,j,cell[j]);
        }
    } 
    
    return 0;
}


mat_struct matrix_init_cells( mat_struct *out, int rows, int cols, int type)
{
    CELL *cell;
    out = G_matrix_init(rows, cols, rows);
    int i,j;
    for (i = 0; i < rows; i ++) {
        cell = Rast_allocate_c_buf();
        Rast_set_c_null_value(cell, cols);
        for(j=0;j< cols;j++) {
            G_matrix_set_element(out,i,j,cell[j]);
        }
    } 
    return *out;
}


    
void save_map(mat_struct *D,char *out_name, int mode )
{

    int i,j,count=1,outfd;
/*    printf("mode=%d\n",mode);*/
CELL sum = 0;
    outfd = Rast_open_c_new(out_name);
     CELL *result;
    for(i=0;i < D->rows;i++) {
       
        result = Rast_allocate_c_buf();
        Rast_set_c_null_value(result, D->cols);
        for(j = 0; j< D->cols; j++) {
            if(mode == 0 || mode == 1) {
                result[j] = (int) G_matrix_get_element(D,i,j);
            }    
            if(mode == 2) {
                CELL val = G_matrix_get_element(D,i,j);
                CELL *c = Rast_allocate_c_buf();
                c[0] = val;
                if(!Rast_is_c_null_value(c)) {
                    sum += c[0];
                    result[j] = sum;
                }
             }
                         
            if(mode == 3) {
                CELL val = G_matrix_get_element(D,i,j);
                CELL *c = Rast_allocate_c_buf();
                c[0] = val;
                if(!Rast_is_c_null_value(c))
                    result[j] = count++;
             }      
        }
        Rast_put_c_row(outfd, result);
    }
    
    Rast_close(outfd);

}



void new_drain(int infd, int type, char *out_name, int nl, int ns, int srow, int scol, int mode)
{
    int i, j;  /* use off_t bufsz for large files ? MM */
    CELL *dir;

    int element, current;
    int right, bottom, diag;

    /* determine the flow direction in each cell.  On outer rows and columns
     * the flow direction is always directly out of the map */

    mat_struct A, B;

    B = matrix_init_cells(&B, nl,ns, type);
    matrix_read_elev(infd,&A,nl,ns,type);   

/*    G_matrix_print(&A);*/
     

    i = srow;
    j = scol;
    
    G_matrix_set_element(&B,srow,scol,G_matrix_get_element(&A,srow,scol));

    while( j < ns)
    {
        current = G_matrix_get_element(&A,i,j);
        right = G_matrix_get_element(&A,i,j+1);

        bottom = G_matrix_get_element(&A,i+1,j);
        diag = G_matrix_get_element(&A,i+1,j+1);
        
        element = right;
        int mb,mr,md;
        mb = md = 0; mr = 1;

        if (element > bottom) {
            mb = 1;
            md = mr = 0;
            element = bottom;
        }

        if (element > diag) {
            md = 1;
            mr = mb = 0;        
            element = diag;
        }

        if(current <= element)
            break;

        if(mr) j++;
     
        if(md) { j++;    i++;}

        if(mb) i++;
        
        G_matrix_set_element(&B,i,j,element);
    }

    save_map(&B,out_name,mode);
    
/*    G_matrix_free(&A);*/
/*    G_matrix_free(&B);*/

    return;
}
